
// AlphaSize.java
// Andrew Davison, May 2022, ad@fivedots.coe.psu.ac.th

/* Generate a PNG image of size width x height with the loaded
   image placed in the center. The new image has an alpha channel
   so the new pixels are transparent.
*/
 
import java.awt.image.*;



public class AlphaSize 
{

  public static void main(String[] args)
  {
    if (!((args.length == 1) || (args.length == 3))) {
      System.out.println("Usage: java AlphaSize fnm [ width height ]");
      return;
    }
      
    BufferedImage im = Pics.load(args[0]);
    if (im == null) {
      System.out.println("Could not load an image from " + args[0]);
      return;
    }

    BufferedImage nIm = null;
    if (args.length == 3) {
      int nWidth = Integer.parseInt(args[1]);
      int nHeight = Integer.parseInt(args[2]);
      nIm = Pics.alpha(im, nWidth, nHeight);
    }
    else
      nIm = Pics.alpha(im);

    String fnm = Pics.getName(args[0]) + "New.png";
    Pics.save(nIm, fnm);
  }  // end of main()



}  // end of AlphaSize class


