
// Carpet.java
// Andrew Davison, May 2022, ad@fivedots.coe.psu.ac.th

/*  A triangle shape, textured with a PNG
*/

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.util.*;
import java.util.function.*;



public class Carpet
{
  private static Tile carpetTile;


  public static void main(String args[])
  {
    double[] xs = {42, 105, 169}; 
    double[] ys = {38, 149, 38};
    Shape s = ShapeOps.points(xs, ys);
     /*  The coordinate were obtained by examining the carpet PNG 
         using MS Paint. They don't quite define an equilateral
         triangle, so built-in tiling introduces errors as it
         spreads out from the middle.
     */

    carpetTile = new Tile(s, "carpet");   
                  // the tile points will be labelled C0, C1, ...

    Graphics2D g2d = carpetTile.getGraphics();
    g2d.setPaint(Pics.loadTex("data/carpet.png"));
    g2d.fill(s); 

    carpetTile.view();
    carpetTile.reportPoints();

    // uses generated inner and outer points; see Tile.view() display
 
    PointPairs ptPairs = new PointPairs(carpetTile);
    ptPairs.print();
      // all points can match with all points

    Function<String, Tile> genTile = 
                      (String nm)->{return carpetTile.clone();};
       // only one tile is used

    // draw tiles on the screen
    ImageViewer iview = Pics.view("Carpet", Pics.altScreen());
    Search.tileLocs(carpetTile, ptPairs, iview, genTile);
    Pics.save(iview.getImage(), "SavedPics/carpetFloor.png");

  } // end of main()


} // end of Carpet class
