
// DrawBoxes.java
// Andrew Davison, May 2022, ad@fivedots.coe.psu.ac.th


import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.util.*;


public class DrawBoxes
{

  public static void main(String args[])
  {
    Tile t = new Tile("data/box.png");
    t.addPt("C0", 116,76);   // ccw order
    t.addPt("C1", 61,77);    // obtained by viewing the image in MS Paint
    t.addPt("C2", 88,125);
    t.addPt("C3", 116,174); 
    t.addPt("C4", 145,125);
    t.addPt("C5", 173,77);
       // the points do not correspond to all the 'corners' in the image 

    t.view();
    t.reportPoints();

    ImageViewer iview = Pics.view("Draw Boxes", Pics.altScreen());
    BufferedImage scrIm = iview.getImage();
    int pWidth = scrIm.getWidth();
    int pHeight = scrIm.getHeight();

    double rowOffset = t.length("C0","C3");  // vertical distance in the image
    Point2D.Double nextPt;
    int y = 50;  // a magic number to start

    // display tiles row-by-row
    while (y < pHeight) {
      nextPt = new Point2D.Double(0,y);
      while (nextPt.x < pWidth) {
        // draw two tiles diagonally
        t.drawAt(scrIm, "C2", nextPt);
        t.drawAt(scrIm, "C1", t.getPtLoc("C4"));  // t is redrawn at a new position
        nextPt = t.getPtLoc("C5"); 
        iview.repaint();
      }
      y += rowOffset;
      Pics.pause(100);   // delay after each row is drawn
    }

    Pics.save(scrIm, "SavedPics/boxes.png");
  } // end of main()


} // end of DrawBoxes class
