
// Traps.java
// Andrew Davison, May 2022, ad@fivedots.coe.psu.ac.th

/* Tile the screen with trapezoids using tileLocs().
   The inner and outer points are generated automatically.
   The point pairs are generated based on the lengths of
   the sides of the shape.
*/

import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.util.function.*;
import java.awt.geom.*;



public class Traps
{
  private static final Color[] colors = { 
       new Color(199,255,244), new Color(255, 210, 199),
       new Color(255, 238, 119), new Color(221, 199, 255)
  };   // https://www.sessions.edu/color-calculator/

  private static Random rand = new Random();

  private static Tile trap;


  public static void main(String args[])
  {
    trap = new Tile("data/trapTile.txt");
    Graphics2D g2d = trap.getGraphics();
    // red circle
    g2d.setColor(Color.RED);
    g2d.fillOval(70, 25, 10, 10);  // near top side
    trap.view();
    trap.reportPoints();

    PointPairs ptPairs = PointPairs.matchLens(trap);
    // ptPairs.print();

    Function<String, Tile> genTile = 
       (String nm)->{ return trap.colorChg(
                         colors[rand.nextInt(colors.length)]); };
       // randomly color the tiles

    // draw tiles on the screen
    ImageViewer iview = Pics.view("Draw Trapezoids", Pics.altScreen());
    Search.tileLocs(trap, ptPairs, iview, genTile);
    Pics.save(iview.getImage(), "SavedPics/trapezoids.png");
  } // end of main()


} // end of Traps class
