
// Triangles.java
// Andrew Davison, May 2022, ad@fivedots.coe.psu.ac.th

/* Draw triangle tiles using tileLocs(). 
   See DrawTris.java for how this tile can be drawn row-by-row.

   The same image is used in DrawHexs.java to draw hexagons.
*/

import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.util.function.*;
import java.awt.geom.*;



public class Triangles
{
  private static Tile tri;


  public static void main(String args[])
  {
    tri = new Tile("data/trif.png");
    tri.addPt("A", 51,6);   // added in ccw order
    tri.addPt("B", 4,86);
    tri.addPt("C", 97,86);

    double[] dxs = { 50, 40, 25, 18, 40, 62, 78, 69, 57 };
    double[] dys = { 25, 39, 68, 76, 76, 76, 76, 59, 32 };
    tri.addInners(dxs, dys);

    tri.addOuter("A", "B", 22,40);
    tri.addOuter("B", "C", 50,92);
    tri.addOuter("C", "A", 77,39);

    tri.view();
    tri.reportPoints();

    PointPairs ptPairs = new PointPairs(tri); // all pts match

    Function<String, Tile> genTile = 
                      (String nm)->{return tri.clone();};


    // draw tiles on the screen
    ImageViewer iview = Pics.view("Triangles", Pics.altScreen());
    Search.tileLocs(tri, ptPairs, iview, genTile);
    Pics.save(iview.getImage(), "SavedPics/triangles.png");
  } // end of main()


} // end of Triangles class
